/* ========================================
 *  Console7Cascade - Console7Cascade.h
 *  Created 8/12/11 by SPIAdmin 
 *  Copyright (c) 2011 __MyCompanyName__, Airwindows uses the MIT license
 * ======================================== */

#ifndef __Console7Cascade_Console7Cascade_H
#define __Console7Cascade_Console7Cascade_H

#include "../../../configuration.h"
#ifdef SHR3D_SFX_CORE_AIRWINDOWS

#include "../common/airwin_consolidated_base.h"


namespace airwinconsolidated::Console7Cascade {
enum {
	kParamA = 0,
  kNumParameters = 1
}; //


class Console7Cascade final : public SfxCoreExtensionV1
{
public:
    Console7Cascade();
    ~Console7Cascade();
    void processBlock(float** inputs, float** outputs, int sampleFrames) override;
    int getParameterCount() const override;
    float getParameter(int index) override;
    void setParameter(int index, float value) override;
    void getParameterLabel(int index, char *text) override;
    void getParameterName(int index, char *text) override;
    void getParameterDisplay(int index, char *text) override;
private:
    
	double gainchase;
	double chasespeed;
	
	double biquadA[15];
	double biquadB[15];
	double biquadC[15];
	double biquadD[15];
	double biquadE[15];
	
	uint32_t fpdL;
	uint32_t fpdR;
	//default stuff
	
    float A;
};

} // end namespace

#endif // SHR3D_SFX_CORE_AIRWINDOWS

#endif
